
#ifndef __node_num3__
#define __node_num3__
const int NODENUM3=200;
#endif

#ifndef __neighbors_table_h__
#define __neighbors_table_h__




/*======================================================================================================
  PROBED NEIGHBORS
  ======================================================================================================*/
class Neighbor {
  private:
        int id;
        double expiration;
        //The number of neighbors it shares with my predecessor
        int value;
        int participant;
  public:
        Neighbor()
                {
                 id=-1;
                 expiration=-1;
                 value=-1;
                 participant=0;
                }
        Neighbor(int id_ass)
                {
                  id=id_ass;
                  expiration=-1;
                  value=-1;
                  participant=0;
                 }
         //Fake is only to distinguish from the other constructor        
        Neighbor(int id_ass, double expiration_ass, int part)
                {
                 id=id_ass;
                 expiration=expiration_ass;
                 value=-1;
                 participant=part;
                }
        Neighbor(int id_ass, double expiration_ass,  int value_ass, int part)
                {
                 id=id_ass;
                 expiration=expiration_ass;
                 value=value_ass;
                 participant=part;
                }
        int getId() {return id;}
        double getExpiration() {return expiration;}
        void setExpiration(double expiration_ass){expiration=expiration_ass;}
        int operator== (Neighbor n2) {return n2.getId()==id;}
        int setValue(int val) {value=val;}
        int getValue (){return value;}
        int getPart() {return participant;}
        };
        

class Neighbors_Table {
  private:
        Neighbor* v[NODENUM3];
        int v_len;
        int pos;
        int number_of_part;
  public:
        Neighbors_Table(){
                        pos=0;
                        v_len=0;
                        number_of_part=0;};

        Neighbors_Table(int* nl, int nlen)
             {
              pos=0;
              v_len=0;
              for(int j=0; j<nlen;j++)
                  {
                   insert(nl[j]);
                  }
               number_of_part=0;   
              }

        void insert(int n)
             {
              Neighbor* n1= new Neighbor(n);
              v[v_len]=n1;
              v_len++;              
             }                     
	     

        void insert(Neighbor n)
             {
              Neighbor* n1= new Neighbor(n.getId(),n.getExpiration(),n.getValue(),n.getPart());
              v[v_len]=n1;
              v_len++;
              if(n.getPart()==1)number_of_part++;
             }
             
                   
        Neighbor* get(int p) {if(p<v_len) return new Neighbor(v[p]->getId(),v[p]->getExpiration(),
                                       v[p]->getValue(),v[p]->getPart());}
        int length(){return v_len;}
        int contains(Neighbor n)
            {
             int j=0, found=0;
             while (found==0 && j<v_len)
                {
                 if(v[j]->getId()==n.getId()) found=1;
                 j++;
                }
             return found;
            }
            
        int contains(int n)
            {
             int j=0, found=0;
             while (found==0 && j<v_len)
                {
                 if(v[j]->getId()==n) found=1;
                 j++;
                }
             return found;
            }

        //Update the expiration timer of the required node
        void update (int n, double next_expiration)
            {
             int j=0;
             while ( j<v_len)
                {
                 if(v[j]->getId()==n) v[j]->setExpiration(next_expiration);
                 j++;
                }             
            }

        //Deletes the entry for the required neighbor
        void del (Neighbor n)
            {
             int j=0,k=0, found=0;
             while (j<v_len && found==0)
                {
                 if(v[j]->getId()==n.getId())
                     {
                      found=1;
                      if(v[j]->getPart()==1)number_of_part--;
		                  for(k=j;k<v_len-1;k++)
                          v[k]=v[k+1];
                      v_len--;
                     }
                 j++;
                }
     	        
             }

        void empty()
            {
             v_len=0;
            }

        int getAll(int* neigh)
            {
             int j=0;
             while (j<v_len)
                {
                 neigh[j]=v[j]->getId();
                 j++;
                }
             return v_len;
            }

        int getPart(){return number_of_part;}
            
        };


#endif

