
#include "redman.h"




#include <stdlib.h>

#include "config.h"
#include "agent.h"
#include "ip.h"
#include "node.h"
#include <random.h>


int hdr_red::offset_;

/*
 *This code implements TCL hooks for the redman packet header (RedmanHeader), the agent class (RedmanClass),
 *the redman partner (RedmanPartner). The last entity is in charge of intercepting broadcast packets arriving
 *at the current node toward the Node entry point.
 */
class RedmanHeaderClass : public PacketHeaderClass {
public:
	RedmanHeaderClass() : PacketHeaderClass ("PacketHeader/RED", sizeof(hdr_red)) {
			bind_offset(&hdr_red::offset_);
		}
	}
class_redhdr;


static class RedmanClass : public TclClass {
public:
  RedmanClass() : TclClass("Agent/Redman") {}
  TclObject* create(int argc , const char*const* argv){
      assert(argc == 5);
      return (new RedmanAgent((nsaddr_t) atoi(argv[4])));
	  }
  virtual void bind();
  virtual int method (int argc, const char*const* argv);
} class_redman;


static class RedmanPartnerClass : public TclClass {
public:
        RedmanPartnerClass() : TclClass("RedmanPartner") {}
        TclObject* create(int, const char*const*) {
                return (new RedmanPartner());
        }
} class_redmanpartner;



//==================================================================================================/
//=========================STATIC VARIABLE BINDINGS=================================================/
//==================================================================================================/

void RedmanClass::bind()
{
  TclClass::bind();
  add_method("disc_delay");
  add_method("part_adv_interval");
  add_method("part_adv_delay");
  add_method("limit");
  add_method("hello_period");
  add_method("hello_delay");
  add_method("check_hello_period");
  add_method("probe_wait_interval");
  add_method("probe_reply_delay");
  add_method("reflection_limit");
  add_method("replica_hops");
  add_method("search_hops");
  add_method("manager_id");
  add_method("aum_period");
  add_method("aum_check_period");
 }

int RedmanClass::method(int ac, const char*const* av)
{
	Tcl& tcl = Tcl::instance();
	char out[100];
	int argc = ac - 2;
	const char*const* argv = av + 2;

	if (argc == 2) {
    if (strcmp(argv[1], "disc_delay") == 0) {
			      tcl.resultf("%d", RedmanAgent::disc_delay_);
			return (TCL_OK);
		} else if (strcmp(argv[1], "part_adv_interval") == 0) {
			      tcl.resultf("%d", RedmanAgent::part_adv_interval_ );
			return (TCL_OK);
		} else if (strcmp(argv[1], "part_adv_delay") == 0) {
			      tcl.resultf("%d", RedmanAgent::part_adv_delay_);
			return (TCL_OK);
		} else if (strcmp(argv[1], "limit") == 0) {
			      tcl.resultf("%d", RedmanAgent::limit_);
			return (TCL_OK);
    } else if (strcmp(argv[1], "hello_period") == 0) {
			      tcl.resultf("%f", RedmanAgent::hello_period_);
			return (TCL_OK);
		} else if (strcmp(argv[1], "hello_delay") == 0) {
		        tcl.resultf("%f", RedmanAgent::hello_delay_);
			return (TCL_OK);
		} else if (strcmp(argv[1], "check_hello_period") == 0) {
			      tcl.resultf("%f", RedmanAgent::check_hello_period_);
			return (TCL_OK);
		} else if (strcmp(argv[1], "probe_wait_interval") == 0) {
		        tcl.resultf("%f", RedmanAgent::probe_wait_interval_);
			return (TCL_OK);
		} else if (strcmp(argv[1], "probe_reply_delay") == 0) {
			      tcl.resultf("%f", RedmanAgent::probe_reply_delay_);
			return (TCL_OK);
		} else if (strcmp(argv[1], "reflection_limit") == 0) {
			      tcl.resultf("%d", RedmanAgent::reflection_limit_);
			return (TCL_OK);
		} else if (strcmp(argv[1], "replica_hops") == 0) {
			      tcl.resultf("%d", RedmanAgent::replica_hops_);
			return (TCL_OK);
		} else if (strcmp(argv[1], "search_hops") == 0) {
			      tcl.resultf("%d", RedmanAgent::search_hops_);
			return (TCL_OK);
		} else if (strcmp(argv[1], "manager_id") == 0) {
			      tcl.resultf("%d", RedmanAgent::manager_id_);
			return (TCL_OK);
		} else if (strcmp(argv[1], "aum_period") == 0) {
			      tcl.resultf("%f", RedmanAgent::aum_period_);
			return (TCL_OK);
		} else if (strcmp(argv[1], "aum_check_period") == 0) {
			      tcl.resultf("%f", RedmanAgent::aum_check_period_);
			return (TCL_OK);
		} 
	}
	else if (argc==3) {
	        if(strcmp(argv[1],"disc_delay")==0) {
		         RedmanAgent::disc_delay_=atoi(argv[2]);
			 return (TCL_OK);
		} else if(strcmp(argv[1],"part_adv_interval")==0) {
		         RedmanAgent::part_adv_interval_=atoi(argv[2]);
			 return (TCL_OK);
		}	else if(strcmp(argv[1],"part_adv_delay")==0) {
		         RedmanAgent::part_adv_delay_=atoi(argv[2]);
			 return (TCL_OK);
		} else if(strcmp(argv[1],"limit")==0) {
		         RedmanAgent::limit_=atoi(argv[2]);
			 return (TCL_OK);
		} else if(strcmp(argv[1],"hello_period")==0) {
		         RedmanAgent::hello_period_=atof(argv[2]);
			return (TCL_OK);
		} else if(strcmp(argv[1],"hello_delay")==0) {
			       RedmanAgent::hello_delay_=atof(argv[2]);
			return (TCL_OK);
		} else if(strcmp(argv[1],"check_hello_period")==0) {
			       RedmanAgent::check_hello_period_=atof(argv[2]);
			return (TCL_OK);
		} else if(strcmp(argv[1],"probe_wait_interval")==0) {
			       RedmanAgent::probe_wait_interval_=atof(argv[2]);
			return (TCL_OK);
		} else if(strcmp(argv[1],"probe_reply_delay")==0) {
			       RedmanAgent::probe_reply_delay_=atof(argv[2]);
			return (TCL_OK);
		} else if(strcmp(argv[1],"reflection_limit")==0) {
			       RedmanAgent::reflection_limit_=atoi(argv[2]);
			return (TCL_OK);
		} else if(strcmp(argv[1],"replica_hops")==0) {
			       RedmanAgent::replica_hops_=atoi(argv[2]);
			return (TCL_OK);
		} else if(strcmp(argv[1],"search_hops")==0) {
			       RedmanAgent::search_hops_=atoi(argv[2]);
			return (TCL_OK);
		} else if(strcmp(argv[1],"manager_id")==0) {
			       RedmanAgent::manager_id_=atoi(argv[2]);
			return (TCL_OK);
		} else if(strcmp(argv[1],"aum_period")==0) {
			       RedmanAgent::aum_period_=atof(argv[2]);
			return (TCL_OK);
		} else if(strcmp(argv[1],"aum_check_period")==0) {
			       RedmanAgent::aum_check_period_=atof(argv[2]);
			return (TCL_OK);
		} 
	}

	return TclClass::method(ac, av);
}

int RedmanAgent::disc_delay_;
int RedmanAgent::part_adv_delay_;
int RedmanAgent::part_adv_interval_;
int RedmanAgent::limit_;
float RedmanAgent::hello_period_;
float RedmanAgent::hello_delay_;
float RedmanAgent::check_hello_period_;
float RedmanAgent::probe_wait_interval_;
float RedmanAgent::probe_reply_delay_;
int RedmanAgent::reflection_limit_;
int RedmanAgent::replica_hops_;
int RedmanAgent::search_hops_;
int RedmanAgent::manager_id_;
float RedmanAgent::aum_period_;
float RedmanAgent::aum_check_period_;



//=================================================================================================/
//=========================END OF STATIC VARIABLE BINDINGS=========================================/
//=================================================================================================/


//========================CONSTRUCTOR AND COMMAND FOR REDMAN AGENT===============================/
RedmanAgent::RedmanAgent(nsaddr_t id) : Agent(PT_RED), discovery_sent_(0), initiator_(0), received_discovery_(0),
                                        part_(0), send_hello_timer_(this), check_neighbor_timer_(this),
                                        disc_timer_(this), part_adv_timer_(this),probe_wait_timer_(this),
                                        probe_reply_timer_(this),search_probe_wait_timer_(this), replied_(0),
                                        yet_explored_for_search_(false), delegation_timer_(this), probed_state_(0),
					delayed_probe_timer_(this), aum_timer_(this), aum_check_timer_(this), discharge_extract_timer_(this),
					aum_extract_timer_(this)
{
  nid_=id;
  bind("packetSize_", &size_);
}



int RedmanAgent::command(int argc, const char*const* argv)
{

  if (argc == 2) {

        /*
         *The initiator receives this command to start the Boundary identification protocol
         */
        if (strcmp(argv[1], "start") == 0) {
          start();
          return (TCL_OK);
        }

        /*
         *This command starts the Hello packets delivery on the node that receives it.
         *Moreover it schedules the Check Neighbors background routine.
         */
        if(strcmp(argv[1],"startHello") == 0) {
          sendHello();
          check_neighbor_timer_.resched(RedmanAgent::check_hello_period_);
          return (TCL_OK);
        }

        /*
         *This command starts a Resource Replication from the current delegate.
         */
        if(strcmp(argv[1],"replicate") == 0) {
          start_replica_distribution(123,1);
          return (TCL_OK);
        }

        /*
         *This command starts the Resource Replica Search from the current node.
         */
        if(strcmp(argv[1],"search")==0) {
          start_replica_search(123);
          return (TCL_OK);
        }
       
	/*
         *This command starts AUM checks from the manager
         */
        if(strcmp(argv[1],"managerAumCheck")==0) {
          aum_check();
          return (TCL_OK);
        } 

  }

  if (argc == 3) {

        
        /*
         *This command starts a Resource Replication from the current delegate.
         */
        if(strcmp(argv[1],"replicate") == 0) {
          start_replica_distribution(atoi(argv[2]),1);
          return (TCL_OK);
        }

        /*
         *This command starts the Resource Replica Search from the current node.
         */
        if(strcmp(argv[1],"search")==0) {
          start_replica_search(atoi(argv[2]));
          return (TCL_OK);
       }

  }

   if(argc == 4)  {

          /*
           *This command starts a Resource Replication from the current delegate.
           */
          if(strcmp(argv[1],"replicate") == 0) {
            start_replica_distribution(atoi(argv[2]),atoi(argv[3]));
            return (TCL_OK);
          }

   }

  

  
  /*
   *If the command hasn't been processed by RedmanAgent()::command,
   *call the command() function for the base class
   */
  return (Agent::command(argc, argv));
}


//================================END OF CONSTRUCTOR AND COMMAND=============================//



//===============================RECEIVER AND DISPATCHER=====================================//
void RedmanAgent::recv(Packet* pkt, Handler*)
{
  // Access the Ping header for the received packet:
  hdr_red* hdr = HDR_RED(pkt);

  switch (hdr->type)
  	{

     /*BOUNDARIES IDENTIFICATION MESSAGES*/
     case REDMAN_DISC:
         recvDensityDiscovery(pkt);
         Packet::free(pkt);
	   break;
     
     /*NEIGHBORS DETECTION PROTOCOL*/
     case REDMAN_HELLO:
         recvHello(pkt);
         Packet::free(pkt);
     break;

     /*REPLICA DISTRIBUTION PROTOCOL*/
     case REDMAN_REPLICA:
     case REDMAN_DISCHARGE:
         recv_replica_distribution(pkt);
         Packet::free(pkt);
     break;
     
     /*REPLICA SEARCH PROTOCOL*/
     case REDMAN_SEARCH:
         recv_replica_search(pkt);
         Packet::free(pkt);
     break;

     /*REPLICA SEARCH REPLY*/
     case REDMAN_SEARCH_REP:
         recv_replica_search_rep(pkt);
         Packet::free(pkt);
     break;    

     /*NEIGHBOR PROBE*/
     case REDMAN_PROBE:
     case REDMAN_SEARCH_PROBE:
         recv_probe(pkt);
         Packet::free(pkt);
     break;

     
     
     /*NEIGHBOR PROBE REPLY*/
     case REDMAN_PROBE_REP:
     case REDMAN_SEARCH_PROBE_REP:
         recv_probe_rep(pkt);
         Packet::free(pkt);
     break;             
    
     /*=========MANAGER RELATED===================*/
     
     /*MANAGER RECEIVES A REQUEST FOR A REPLICATION DEGREE*/
     case REDMAN_DEGREE_REQ:
     	 recv_degree_req(pkt);
	 Packet::free(pkt);
     break;
     
     /*THE DELEGATE RECEIVES A REPLY*/
     case REDMAN_DEGREE_REP:
     	 recv_degree_rep(pkt);
	 Packet::free(pkt);
     break;
     
     case REDMAN_NEW_REPLICA_PLACED:
     	 update_srt(pkt);
	 Packet::free(pkt);
     break;
     
     /*THE MANAGER RECEIVED A NOTIFICATION BY A NODE EXITING THE NETWORK*/
     case REDMAN_MANAGER_NOTIFY:
     	 recv_leaving_notification(pkt);
	 Packet::free(pkt);
     break;
     
     case REDMAN_REQUIRE_REPLICATION:
     	 manager_required_replication(pkt);
     	 Packet::free(pkt);
     break;
     
     case REDMAN_AUM:
     	 aum_recv(pkt);
	 Packet::free(pkt);
     break;
     
     
	  }

}


  //========================ACTION DISPATCHER WHEN TIMERS FIRE====================//

  /*This method is called when the discovery timeout expires*/
  void RedmanAgent::timeout (int t)
  {
   Packet* pkt;
   int next, j=0,k=0,s=0;
   hdr_red* hdr;
   char out[100];
   Tcl& tcl = Tcl::instance();
   bool trovato=false;
   int table[NODENUM];
   switch (t) {

        /*BOUNDARIES IDENTIFICATION PROTOCOL*/
        case RED_DISC:
	          discover();
	break;
	case RED_ADV:
            advertise();
        break;
        
        /*NEIGHBORS DETECTION PROTOCOL*/
        case SND_HELLO:
              sendHello();
              break;

        case CHECK_NEIGHBORS:
              nb_purge();
              break;

       /*NEIGHBORS PROBE PROTOCOL*/
       case PROBE_REPLY:
              send_probe_rep();
              break;

       /*REPLICA DISTRIBUTION PROTOCOL*/
       case PROBE_WAIT:
              delegate_replica_distribution();
              break;

       case DELEGATION:
              send_replica_distribution(next_delegate_,0);
              break; 

       /*SEARCH PROBE PROTOCOL*/
       case SEARCH_PROBE_WAIT:
              delegate_search();
              break;
	      
       /*==============================MANAGER RELATED TIMEOUTS================================*/
       case PROBE_NEIGHBORS:
       	      probe_neighbors();
	      break;
	      
       case AUM_CHECK:
       	      aum_check();
	      break;

       case AUM_SEND:
       	      aum_send();
	      break;
	      
       case AUM_EXTRACT:
       	      extract_from_queue();
              break;

       case DISCHARGE_EXTRACT:
              extract_from_discharge();
              break;

 }

}

/*================================================================================================
 *                                 BOUNDARIES IDENTIFICATION PROTOCOL
 *================================================================================================*/

/*
 *This method represent the start procedure. This is exploited by the initiator to send
 *the first broadcast packet
 */
void RedmanAgent::start()
{
   // Create a new packet
   Packet* pkt = BCastPacket();
   // Access the Density header for the new packet
   hdr_red_disc* hdr = HDR_RED_DISC(pkt);
   // Set the header inner fields
   // The id of the source
   hdr->disc_srcid=nid_;
   // Packet Type
   hdr->disc_type=REDMAN_DISC;
   // Send the packet
   send(pkt, 0);
   // Set initiator state fields
   // The node has broadcasted its identity
   discovery_sent_=1;
   //This node is the initiator
   initiator_=1;
   // When the part_adv_timer_ fires the node declares if it is willing to
   //participate or not to the hotspot
   part_adv_timer_.resched(RedmanAgent::part_adv_interval_+Random::uniform(RedmanAgent::part_adv_delay_));
}


/*
 *This method is called when the node receives a Density Discovery Messge from the initiator
 *for the identification of the dense MANET boundaries
 */
void RedmanAgent::recvDensityDiscovery(Packet* pkt)
{
    char out[100];
    Tcl& tcl=Tcl::instance();
    struct hdr_red_disc* hdr= HDR_RED_DISC(pkt);
    sprintf( out, "%s recv_discovery %d ", name(), hdr->disc_srcid);
		tcl.eval(out);
    received_discovery_++;
    if(discovery_sent_==0)
			//In this case the node should broadcast its identifier
			{
			 disc_timer_.resched(Random::uniform(RedmanAgent::disc_delay_));
       discovery_sent_=1;
			}
}

/*
 *Nodes disclose their identity to neighbors
 */
void RedmanAgent::discover()
{
	  discovery_sent_=1;
	  Packet* pkt=BCastPacket();
	  //Access the Density header for the new packet
		hdr_red_disc* hdr = HDR_RED_DISC(pkt);
		//Now the problem is to fill hdr_den (header density) fields:
		//first we have to retrieve node's ID
		hdr->disc_srcid = nid_;
		//Packet Type
		hdr->disc_type=REDMAN_DISC;
		// Send the packet
		send(pkt, 0);
		// When the part_adv_timer_ fires the node declares if it is willing to
      		//participate or not to the hotspot
		part_adv_timer_.resched(RedmanAgent::part_adv_interval_+Random::uniform(RedmanAgent::part_adv_delay_));
}

/*
 *This method advertises the user whether the node participate to the dense MANET or not
 */
void RedmanAgent::advertise()
{
  char out[100];
  Tcl& tcl=Tcl::instance();
  if (received_discovery_>=RedmanAgent::limit_ || initiator_)
			{
       part_=1;
			 sprintf(out, "%s participate %d", name(), 1);
      }
  else{
       part_=0;
		   sprintf(out, "%s participate %d", name(), 0);
			}
	tcl.eval(out);
}   


/*======================================================================================================
 *                               NEIGHBORS DETECTION                                                   *
 *=====================================================================================================*/

/*
 *This method only sends a new Hello message and reschedules the Hello Period timer
 */

void RedmanAgent::sendHello()
{
    // Create a new packet
    Packet* pkt = BCastPacket();
    // Access the Redman header for the new packet
    hdr_red_hello* hdr = HDR_RED_HELLO(pkt);
    hdr->hello_type = REDMAN_HELLO;
    hdr->hello_srcid = nid_;
    hdr->hello_part=part_;
    float rit,x,y,k;
              //DEBUG CODE
              char out[100];
              Tcl& tcl = Tcl::instance();
              sprintf (out, "%s hello_sent ", name());
              tcl.eval(out);
    // Send the packet
    send(pkt, 0);
    x=RedmanAgent::hello_period_;
    y=Random::uniform();
    k=RedmanAgent::hello_delay_;
    rit=x+y*k;
    //Reschedule send hello
    if(send_hello_timer_.status()!=TIMER_PENDING) send_hello_timer_.resched(rit);
}

/*
 *This method, called upon the reception of an Hello packet, updates the entry in the current Neighbors
 *table or inserts new records in that table if the sender was previously unseen.
 */
void RedmanAgent::recvHello(Packet* pkt) {

    hdr_red_hello* hdr=HDR_RED_HELLO(pkt);
    int snd=hdr->hello_srcid;
    float x;
    char out[100];
    Tcl& tcl = Tcl::instance();
    float time=Scheduler::instance().clock();

    if (nid_==21 && snd==416 ){
      sprintf(out,"%s",name());
      }
    if(!my_neighbors_table_.contains(snd))
          {
           if(hdr->hello_part) new_neighbor_=snd;
           Neighbor* n1= new Neighbor(snd, Scheduler::instance().clock()+ RedmanAgent::hello_period_*1.15, hdr->hello_part);
           my_neighbors_table_.insert(*n1);
           /*A new node is in this node visibility*/
           if (my_neighbors_table_.length()>=RedmanAgent::limit_ && part_==0)
             {
              //part_=1;
                        if(nid_==21 && snd==416)
                         {
                        //DEBUG CODE
                        sprintf(out, "%s hello_received %d", name(), snd);
                        tcl.eval(out);
                         }
             }
           //Reschedule timers
           //Schedule send hello
           //send_hello_timer_.resched(RedmanAgent::hello_period_+Random::uniform()*RedmanAgent::hello_delay_);
           
              
         } //IF
   else
          {
           my_neighbors_table_.update(snd, Scheduler::instance().clock()+ RedmanAgent::hello_period_*1.15);  
          }

   //Schedule check neighbor timer
   if(check_neighbor_timer_.status()!= TIMER_PENDING)
	             check_neighbor_timer_.resched(RedmanAgent::check_hello_period_);	  
}

/*
 *This method checks whether all neighbors array entries are still valid or not.
 *It purges all timed-out Neighbor Entries.
 */
void RedmanAgent::nb_purge() {
      char out[100];
      int next,j;
      Tcl& tcl = Tcl::instance();
      Neighbor* nb;
      double now = Scheduler::instance().clock();
      int curr=0;
      for(curr=0;curr<my_neighbors_table_.length();) {
         nb=my_neighbors_table_.get(curr);
         if(nb->getExpiration() <= now) {
           my_neighbors_table_.del(*nb);           
           }           
         else curr++;
       }
       if(check_neighbor_timer_.status()!= TIMER_PENDING) check_neighbor_timer_.resched(RedmanAgent::check_hello_period_);

       
      /*IF the number of my neighbors is lower than the limit, then discharge my replicas to one of my neighbors*/
      if(my_neighbors_table_.getPart()<RedmanAgent::limit_ && my_neighbors_table_.getPart()>RedmanAgent::limit_/2
          && part_==1 && my_shared_replicas_.length()>0 )
                 {
                  part_=0;
                                            
                   discharge_queue_= new Discharge_Queue();
                  //Discharge all my replicas
                  for(j=0;j<my_shared_replicas_.length();j++)
                  		  	{
                           //Get the j-th replica
                           Replica my_replica = my_shared_replicas_.get(j);
                  			   //Distribute it
                  			   next=(int)Random::uniform(my_neighbors_table_.length()-1);
                  			   //Store the information needed for the sending of the replication packet
                           replication_forwarding_info_=new Replication_Info(my_neighbors_table_.get(next)->getId(),
 			                                    my_replica.getId(),1,0,1,1,nid_);
                           if(my_neighbors_table_.contains(new_neighbor_))
                                   {
                                     discharge_queue_->insert(new_neighbor_,replication_forwarding_info_);
                                     if(discharge_extract_timer_.status()!=TIMER_PENDING)
                                               discharge_extract_timer_.resched(0.1);
                                            #ifdef DEBUG
                                            sprintf (out, "%s discharge %d %d", name(),
                                                          my_replica.getId(),new_neighbor_);
                                            tcl.eval(out);
                             			          #endif
                                   }
                           else {
                                 discharge_queue_->insert(my_neighbors_table_.get(next)->getId(),replication_forwarding_info_);
                                 if(discharge_extract_timer_.status()!=TIMER_PENDING)
                                               discharge_extract_timer_.resched(0.1);
                                 #ifdef DEBUG
                                 sprintf (out, "%s discharge %d %d", name(),
                                               my_replica.getId(),my_neighbors_table_.get(next)->getId());
                                 tcl.eval(out);
                  			         #endif
                                 }
 			                     //Problema se ne ha piu' di 1
                           if(aum_timer_.status()==TIMER_PENDING) aum_timer_.cancel();
                          }
                    		   
                 }
       
       /*If the number of my neighbors is under the limit, then I notify the manager of my exit*/ 
       else if(my_neighbors_table_.getPart()<RedmanAgent::limit_/2 && part_==1 && my_shared_replicas_.length()>0 )
       		{
		       part_=0;
		                   
      		 notify_manager();
      		 if(aum_timer_.status()==TIMER_PENDING) aum_timer_.cancel();
      		}
       /*else if(my_neighbors_table_.length()>=RedmanAgent::limit_ && part_==0)
       		{
       		 part_=1;
       		 if(aum_timer_.status()!=TIMER_PENDING) aum_timer_.resched(RedmanAgent::aum_period_);
                         #ifdef DEBUG
                         sprintf (out, "%s is_IN", name());
                         tcl.eval(out);
      			             #endif
       		}*/
 }




/*======================================================================================================
 *                               REPLICA DISTRIBUTION                                                  *
 *=====================================================================================================*/

/*
 *This method is used by the current delegate to start the replica distribution
 */
void RedmanAgent::start_replica_distribution(int resource_id, int num_replicas)
{
  char out[100];
  Tcl& tcl=Tcl::instance();
  //Prepare reply packet
  Packet* pkt=allocpkt();
  hdr_red_degree_req* hdr=HDR_RED_DEGREE_REQ(pkt);
  hdr_ip* hdrip=hdr_ip::access(pkt);
  
  
  
  //Replica initialization
  Replica* my_replica = new Replica(resource_id,nid_);
  
  //Update the information about replicas and the owned replica table
  if(!my_replica_table_.contains(*my_replica)) my_replica_table_.insert(*my_replica);
  if(!my_shared_replicas_.contains(*my_replica))my_shared_replicas_.insert(*my_replica);
         
          //DEBUG CODE
          sprintf(out,"%s st_replicate %d", name(), my_replica->getId());
          tcl.eval(out);
 
   //Contact the manager to ask the replication degree
   
   
   //Fill the IP header
   hdrip->daddr() = RedmanAgent::manager_id_;
   hdrip->dport()=500;

   //Fill reply fields
   hdr->deg_req_type=REDMAN_DEGREE_REQ;
   hdr->deg_req_srcid=nid_;
   hdr->deg_req_delegate=nid_;
   hdr->deg_req_resource_id=resource_id;
   //hdr_rep->deg_rep_degree=old_hdr->deg_req_sugg_degree;   
   hdr->deg_req_sugg_degree=num_replicas;   
   
   send(pkt,0);      
   
   //After manager communication I have to schedule my AUM timer if it has not been scheduled yet
   if(aum_timer_.status()!=TIMER_PENDING) aum_timer_.resched(RedmanAgent::aum_period_+Random::uniform(3));
   
    
}

/*
 *This method sends the Replica Distribution Message to another node
 */
void RedmanAgent::send_replica_distribution(int next, int discharge)
{
  Tcl& tcl=Tcl::instance();
  char out[100];
  int j=0;
  // Create a new packet
  Packet* pkt = allocpkt();
  // Access the IP header for the new packet
  hdr_ip* hdrip= hdr_ip::access(pkt);
  // Send to the next neighbor
  hdrip->daddr() = next;
  hdrip->dport()=500;
  //Access the Replica Distribution header 
  hdr_red_replica* hdr=HDR_RED_REPLICA(pkt);

                       #ifdef DEBUG
                       sprintf(out,"%s out_send %d %d", name(),
                             replication_forwarding_info_->getNumReplicasRequired(), next);
                       tcl.eval(out);
    		               #endif
                      
  //Set the Replica Distribution Packet fields
  if(!discharge)hdr->replica_type=REDMAN_REPLICA;
  else hdr->replica_type=REDMAN_DISCHARGE;
  hdr->replica_srcid=nid_;
  hdr->replica_resource_delegate=replication_forwarding_info_->getDelegate();
  hdr->replica_resource_id=replication_forwarding_info_->getResourceId();
  hdr->replica_num_replicas_required=replication_forwarding_info_->getNumReplicasRequired();
  hdr->replica_acceptors_num=replication_forwarding_info_->getAcceptorsNum();
  if(hdr->replica_acceptors_num!=0) replication_forwarding_info_->getAcceptors(hdr->replica_acceptors);
  hdr->replica_hops_to_next=replication_forwarding_info_->getHopsToNext();

  //Copy the list of my neighbors in the packets  
  for(j=0;j<my_neighbors_table_.length();j++)
      hdr->replica_previous_neigh[j]=my_neighbors_table_.get(j)->getId();
  hdr->replica_previous_neigh_num=my_neighbors_table_.length();

  //If the delegate is exiting and is discharging its resource it indicates here
  hdr->replica_is_exiting=replication_forwarding_info_->isDelegateExiting();
  hdr->replica_exiting_delegate=replication_forwarding_info_->getExitingDelegate();
  
              #ifdef REFLECTION
              //This is an optimization variable
              hdr->replica_reflection=reflect_;
              #endif
  
  //Change the host state to delegate code
  probed_state_=2;
  
  //Send the packet
  send(pkt,0);
}

/*
 *This method parses the Replica Distribution packet received and, in case, triggers
 *the next node choice procedure.
 */
void RedmanAgent::recv_replica_distribution(Packet* pkt)
{
  char out[100];
  Tcl& tcl=Tcl::instance();
  int terminate=0;
  Packet* out_pkt;
  Replica* received_replica;
  int j;
  hdr_red_replica* hdr=HDR_RED_REPLICA(pkt);
  hdr_red_probe* hdrprobe;

  if(part_==1)
  {
      //Set current node inner fields basing on the Replica Distribution Packet fields
      //in particular the Replication Forwarding Information ...
      replication_forwarding_info_=new Replication_Info(hdr->replica_resource_delegate, hdr->replica_resource_id,
           hdr->replica_num_replicas_required,hdr->replica_acceptors_num,hdr->replica_acceptors,hdr->replica_hops_to_next - 1,
           hdr->replica_is_exiting, hdr->replica_exiting_delegate);

      //.. and the list of the neighbors of the previous delegate
      previous_delegate_neighbors_= new Neighbors_Table(hdr->replica_previous_neigh, hdr->replica_previous_neigh_num);

      //Update the replica table
      received_replica = new Replica(hdr->replica_resource_id, hdr->replica_resource_delegate);
      if(!my_replica_table_.contains(*received_replica)) my_replica_table_.insert(*received_replica);



                       #ifdef REFLECTION
                       im_after_reflection_=hdr->replica_reflection;
                       #endif
                       #ifdef DEBUG
                       sprintf(out,"%s out_replicate %d", name(),
                             replication_forwarding_info_->getNumReplicasRequired());
                       tcl.eval(out);
    		               #endif
                      

      //Termination condition
      if(replication_forwarding_info_->getHopsToNext()==0 && replication_forwarding_info_->getNumReplicasRequired()!=0 )
            {
             //If I do not have this replica yet, I should locally replicate it and communicate to the manager

             if(!my_shared_replicas_.contains(*received_replica))
    	         {
    		        my_shared_replicas_.insert(*received_replica);
                //I send to the manager also the information about the situation of the last delegate that
                //sent me the resource (if it is leaving the network)
                communicate_manager(replication_forwarding_info_->getResourceId(),
                        replication_forwarding_info_->isDelegateExiting(), replication_forwarding_info_->getExitingDelegate());

                //Replicate locally
                replication_forwarding_info_->decNumReplicasRequired();
                replication_forwarding_info_->addAcceptor(nid_);
    	          //After manager communication I have to schedule my AUM timer if it has not been scheduled yet
    		        if(aum_timer_.status()!=TIMER_PENDING) aum_timer_.resched(RedmanAgent::aum_period_+Random::uniform(3));

        				#ifdef DEBUG
        				sprintf(out,"%s out_acceptor %d", name(), replication_forwarding_info_->getResourceId());
        				tcl.eval(out);
        				#endif

            			if(replication_forwarding_info_->getNumReplicasRequired()==0)
                 			{
                 				//Terminate

                 			}
            			else  {
            				     replication_forwarding_info_->setHopsToNext(RedmanAgent::replica_hops_);
            				     delayed_probe_timer_.resched(5);
             			      }
            		}
             	//If I have the replica yet I forward it as if was not the correct hop
             	else    {
             	          replication_forwarding_info_->setHopsToNext(1);
                               probe_neighbors();
             	        }

             }
	 


  //Most suitable neighbor detection
  else if(replication_forwarding_info_->getNumReplicasRequired()!=0)
        {
         //Local probe packet broadcast
         out_pkt=BCastPacket();
         hdrprobe=HDR_RED_PROBE(out_pkt);

         //Set probe fields
         hdrprobe->probe_type=REDMAN_PROBE;
         hdrprobe->probe_srcid=nid_;
         hdrprobe->probe_previous_neigh_num=previous_delegate_neighbors_->getAll(hdrprobe->probe_previous_neigh);
         hdrprobe->probe_replica_placement=replication_forwarding_info_->getDelegate();
         hdrprobe->probe_resource_id=replication_forwarding_info_->getResourceId();

         send(out_pkt,0);

         //Set local variables and schedule the Probe Replies check
         my_probed_neighbors_.empty();
         //Schedule the timer to check the received replies
         probe_wait_timer_.resched(RedmanAgent::probe_wait_interval_);
        }

  }
}

/*
 *Delegate Replica Distribution chooses one of current candidate acceptor neighbors
 *as the next candidate acceptor and delegates it the verification of its suitability
 */
void RedmanAgent::delegate_replica_distribution()
{
 int j=0, currentMin=1000;
 Packet* pkt;
 Tcl& tcl=Tcl::instance();
 char out[100];
 Neighbor *nb, *current_best;
 
 for(j=0;j<my_probed_neighbors_.length();j++)
    {
     nb=my_probed_neighbors_.get(j);
     if(nb->getValue()<currentMin)
        {
         currentMin=nb->getValue();
         current_best=nb;
        }
    }
    
  if (currentMin!=1000) send_replica_distribution(current_best->getId(),0);
  my_probed_neighbors_.empty();
  
  //SE PERO' NON HO VICINI DEVO TENERMI LA REPLICA O RIMANDARLA INDIETRO
}


/*======================================================================================================
 *                                     REPLICA SEARCH                                                  *
 *=====================================================================================================*/

void RedmanAgent::start_replica_search(int resource_id)
{

  char out[100];
  Tcl& tcl=Tcl::instance();
  int next;
  bool trovato=false;
  
  
    //DEBUG CODE
    sprintf(out,"%s st_search", name());
    tcl.eval(out);
  
  //Local variable settings
  search_forwarding_info_=new Replication_Info(nid_,resource_id,RedmanAgent::search_hops_);
  
  send_replica_search(my_neighbors_table_.get((int)Random::uniform(my_neighbors_table_.length()-1))->getId());
  
}


void RedmanAgent::send_replica_search(int next)
{

  int j=0;
  // Create a new packet
  Packet* pkt = allocpkt();
  // Access the IP header for the new packet
  hdr_ip* hdrip= hdr_ip::access(pkt);
  // Send to the next neighbor
  hdrip->daddr() = next;
  hdrip->dport()=500;
  //Access the Replica Search header
  hdr_red_search* hdr=HDR_RED_SEARCH(pkt);
   
  //Set the Replica Search Packet fields
  hdr->search_type=REDMAN_SEARCH;
  hdr->search_srcid=nid_;
  hdr->search_searcher=search_forwarding_info_->getDelegate();
  hdr->search_resource_id=search_forwarding_info_->getResourceId();
  hdr->search_hop_limit=search_forwarding_info_->getHopsToNext();

  //Copy the list of my neighbors in the packets
  for(j=0;j<my_neighbors_table_.length();j++)
      hdr->search_previous_neigh[j]=my_neighbors_table_.get(j)->getId();
  hdr->search_previous_neigh_num=my_neighbors_table_.length();

  //Send the packet
  send(pkt,0);
  
}


void RedmanAgent::recv_replica_search(Packet* pkt)
{
  char out[100];
  Tcl& tcl=Tcl::instance();
  bool terminate=false;
  Packet* out_pkt;
  int j;
  hdr_red_search* hdr=HDR_RED_SEARCH(pkt);
  hdr_red_probe* hdrprobe;

  //Set current node inner fields basing on the Replica Search Packet fields
  if(search_fwd_==0) search_fwd_=hdr->search_srcid;

  search_forwarding_info_= new Replication_Info(hdr->search_searcher,hdr->search_resource_id,hdr->search_hop_limit - 1);
  
  //Copy the previous neighbors table
  previous_delegate_neighbors_= new Neighbors_Table(hdr->search_previous_neigh, hdr->search_previous_neigh_num);
         

  //if(! yet_explored_for_search_)
    //{
      //Termination condition
      if(my_replica_table_.contains(hdr->search_resource_id))
            {
               //found means that the current searched resource has been found
               found_=1;
               //Choose which reference return to the sender (i.e. which replica host)
               replied_replica_placement_=reply_placement
                            (my_replica_table_.getFromId(hdr->search_resource_id));
               //If I have not replied so fare, I reply                            
               if(!replied_) search_reply(replied_replica_placement_);
               sprintf(out, "%s found", name());
               tcl.eval(out);
            }
      else if(hdr->search_hop_limit==0)
            {
             if(!replied_) search_reply(-1);
             //replica_not_found();
            }
      else if(hdr->search_hop_limit>0){
             //DEBUG CODE
             sprintf(out,"%s out_search", name());
             tcl.eval(out);

             //Local probe packet broadcast
             out_pkt=BCastPacket();
             hdrprobe=HDR_RED_PROBE(out_pkt);
             hdrprobe->probe_type=REDMAN_SEARCH_PROBE;
             hdrprobe->probe_srcid=nid_;
             for(j=0;j<previous_delegate_neighbors_->length();j++)
                   hdrprobe->probe_previous_neigh[j]=previous_delegate_neighbors_->get(j)->getId();
             hdrprobe->probe_previous_neigh_num=previous_delegate_neighbors_->length();
             hdrprobe->probe_resource_id=search_forwarding_info_->getResourceId();
             send(out_pkt,0);

             //Set local variables and schedule the Probe Replies check
             search_probe_wait_timer_.resched(RedmanAgent::probe_wait_interval_);
            }
    //}
}

void RedmanAgent:: delegate_search()
{
 int j=0, currentMin=5000, minNode;
 char out[100];
 Tcl& tcl=Tcl::instance();
 Packet* pkt;
 hdr_ip* hdrip;
 Neighbor *nb,*current_best;
 
 for(j=0;j<my_probed_neighbors_.length();j++)
    {
     nb=my_probed_neighbors_.get(j);
     if(nb->getValue()<currentMin)
        {
         currentMin=nb->getValue();
         current_best=nb;
        }
    }

 //Delegate the Replica Distribution
 if(!found_)send_replica_search(current_best->getId());
 //Here finishes my search role (except from passing messages coming from repliers): I clean data structures
 found_=0;
 replied_=0;
 my_probed_neighbors_.empty();
}

/*
 *This method is used, when either the replica placement has been found or the time limit has
 *fired, to reply to the searcher
 */
void RedmanAgent::search_reply(int place)
{
  //I have replied
  replied_=1;
  
  //Create the reply packet
  Packet* pkt=allocpkt();
  hdr_red_search_rep* hdr=HDR_RED_SEARCH_REP(pkt);
  hdr_ip* hdrip=hdr_ip::access(pkt);

  
  //Fill the IP header
  hdrip->daddr() = search_fwd_;
  hdrip->dport()=500;

  //Fill reply fields
  hdr->search_rep_type=REDMAN_SEARCH_REP;
  hdr->search_rep_srcid=nid_;
  hdr->search_rep_searcher=search_forwarding_info_->getDelegate();
  hdr->search_rep_resource_id=search_forwarding_info_->getResourceId();
  hdr->search_rep_replica_placement=place;

  send(pkt,0);
}

void RedmanAgent::recv_replica_search_rep(Packet* old_pkt)
{
  char out[100];
  Tcl& tcl=Tcl::instance();
  hdr_red_search_rep* old_hdr=HDR_RED_SEARCH_REP(old_pkt);
  //This packet is the new one used to avoid routing protocols
  Packet* pkt=allocpkt();
  hdr_red_search_rep* hdr=HDR_RED_SEARCH_REP(pkt);
  hdr_ip* hdrip=hdr_ip::access(pkt);
  
  //Check whether I was the searcher or not
  if(old_hdr->search_rep_searcher==nid_)
      {   
       sprintf(out, "%s search_finished %d", name(),  old_hdr->search_rep_replica_placement);
       tcl.eval(out);
      }
  else
      {
       //Fill the IP header
       hdrip->daddr() = search_fwd_;
       hdrip->dport()=500;

       //Fill reply fields
       hdr->search_rep_type=REDMAN_SEARCH_REP;
       hdr->search_rep_srcid=nid_;
       hdr->search_rep_searcher=old_hdr->search_rep_searcher;
       hdr->search_rep_resource_id=old_hdr->search_rep_resource_id;
       hdr->search_rep_replica_placement=old_hdr->search_rep_replica_placement;

       send(pkt,0);
      }

}

int RedmanAgent::reply_placement(Replica r)
{
  int* v=r.getPlacement();
  return v[0];
}


/*======================================================================================================
 *                                     REPLICA MANAGER                                                 *
 *=====================================================================================================*/

void RedmanAgent::recv_degree_req(Packet* pkt)
{
   hdr_red_degree_req* hdr=HDR_RED_DEGREE_REQ(pkt);
   Tcl& tcl=Tcl::instance();
   char out[100];
   
   //Prepare reply packet
   Packet* rep_pkt=allocpkt();
   hdr_red_degree_rep* hdr_rep=HDR_RED_DEGREE_REP(rep_pkt);
   hdr_ip* hdrip=hdr_ip::access(rep_pkt);
   int decided_degree=hdr->deg_req_sugg_degree;
   
   Replica* replica= new Replica(hdr->deg_req_resource_id, hdr->deg_req_delegate, 
                     decided_degree, Scheduler::instance().clock()+RedmanAgent::aum_period_*1.2);
   srt_.insert(replica);
    
   //Fill the IP header
   hdrip->daddr() = hdr->deg_req_delegate;
   hdrip->dport()=500;

                #ifdef DEBUG
                sprintf(out, "%s man_recv_comm %d %d", name(), hdr->deg_req_resource_id, 1);
                tcl.eval(out);
                #endif
   
   //Fill reply fields
   hdr_rep->deg_rep_type=REDMAN_DEGREE_REP;
   hdr_rep->deg_rep_srcid=nid_;
   hdr_rep->deg_rep_resource_id=hdr->deg_req_resource_id;
   //hdr_rep->deg_rep_degree=old_hdr->deg_req_sugg_degree;   
   hdr_rep->deg_rep_degree=decided_degree;   
   
   send(rep_pkt,0);
   
}

void RedmanAgent::recv_degree_rep(Packet* pkt)
{
   
   
   hdr_red_degree_rep* hdr=HDR_RED_DEGREE_REP(pkt);
   
     
   //Store the information needed for the sending of the replication packet
   replication_forwarding_info_=new Replication_Info(nid_,hdr->deg_rep_resource_id,
                                           hdr->deg_rep_degree-1,0,RedmanAgent::replica_hops_);
   
   send_replica_distribution((my_neighbors_table_.get((int)Random::uniform(my_neighbors_table_.length()-1)))->getId(),0); 
   
   
}


////////////////////////////////////=======NEW REPLICAS ARE PLACED===========/////////////////////////////////
/*
 *Next two method are called by nodes receiving copies of a replica.
 *First, they notify the manager; then, after a short timeout, they probe their neighbors
 */
void RedmanAgent::communicate_manager(int resource_id, int isexitingdelegate, int exitingdelegate)
{

   //Prepare reply packet
   Packet* pkt=allocpkt();
   hdr_red_new_replica* hdr=HDR_RED_NEW_REPLICA(pkt);
   hdr_ip* hdrip=hdr_ip::access(pkt);
   
    
   //Fill the IP header
   hdrip->daddr() = RedmanAgent::manager_id_;
   hdrip->dport()=500;

   //Fill reply fields
   hdr->new_replica_type=REDMAN_NEW_REPLICA_PLACED;
   hdr->new_replica_srcid=nid_;
   hdr->new_replica_resource_id=resource_id;
   hdr->new_replica_delegate=nid_;
   hdr->new_replica_is_delegate_exiting=isexitingdelegate;
   hdr->new_replica_exiting_delegate=exitingdelegate;
     
   
   send(pkt,0);
}

void RedmanAgent::probe_neighbors()
{
   Packet* out_pkt;
   hdr_red_probe* hdrprobe;
   //Local probe packet broadcast
   out_pkt=BCastPacket();
   hdrprobe=HDR_RED_PROBE(out_pkt);

   //Set probe fields
   hdrprobe->probe_type=REDMAN_PROBE;
   hdrprobe->probe_srcid=nid_;
   hdrprobe->probe_previous_neigh_num=previous_delegate_neighbors_->getAll(hdrprobe->probe_previous_neigh);
   hdrprobe->probe_replica_placement=replication_forwarding_info_->getDelegate();
   hdrprobe->probe_resource_id=replication_forwarding_info_->getResourceId();
   send(out_pkt,0);

   //Set local variables and schedule the Probe Replies check
   my_probed_neighbors_.empty();
   //Schedule the timer to check the received replies
   probe_wait_timer_.resched(RedmanAgent::probe_wait_interval_);
} 

void RedmanAgent::update_srt(Packet* pkt)
{
   Tcl tcl=Tcl::instance();
   char out[100];
   
   hdr_red_new_replica* hdr=HDR_RED_NEW_REPLICA(pkt);

   if(hdr->new_replica_is_delegate_exiting==1) srt_.deleteOwner(hdr->new_replica_exiting_delegate);
   Replica* replica= new Replica(hdr->new_replica_resource_id, hdr->new_replica_delegate,
                                    Scheduler::instance().clock()+RedmanAgent::aum_period_*1.2);
   srt_.update(replica);
   
   
   #ifdef DEBUG
   sprintf(out, "%s man_recv_comm %d %d", name(), hdr->new_replica_resource_id,
                       srt_.getFromId(replica->getId()).getPlacementLength());
   tcl.eval(out);

   for(int j=0;j<srt_.length();j++)
		{
		 Replica rep=srt_.get(j);
		 sprintf(out, "%s srt_dump %d %d %d", name(), rep.getId(), rep.getDegree(), rep.getLastPlacement());
                 tcl.eval(out);
		}
	#endif

}

/*
 *This method is used by a node exited from the network to notify the manager that
 *its resources should be replicated
 */
void RedmanAgent::notify_manager()
{
   Tcl& tcl=Tcl::instance();
   char out[100];
   //Prepare reply packet
   Packet* pkt=allocpkt();
   hdr_red_man_not* hdr=HDR_RED_MAN_NOT(pkt);
   hdr_ip* hdrip=hdr_ip::access(pkt);
   
    
   //Fill the IP header
   hdrip->daddr() = RedmanAgent::manager_id_;
   hdrip->dport()=500;

   //Fill reply fields
   hdr->man_not_type=REDMAN_MANAGER_NOTIFY;
   hdr->man_not_srcid=nid_;
   hdr->man_not_delegate=nid_;
   for(int k=0;k<my_shared_replicas_.length();k++)
       {
   	    hdr->man_not_resource_id[k]=my_shared_replicas_.get(k).getId();
                         #ifdef DEBUG
                         sprintf (out, "%s notifies %d", name(), my_shared_replicas_.get(k).getId());
                         tcl.eval(out);
      			             #endif
       }
   hdr->man_not_resource_id_num=my_shared_replicas_.length();  
   
   send(pkt,0);
}

/*
 *This method is called when a manager receives a notification by a node that abandoned
 *the network
 */
void RedmanAgent::recv_leaving_notification(Packet* pkt)
{
   Tcl tcl=Tcl::instance();
   char out[100];
   
   hdr_red_man_not* hdr=HDR_RED_MAN_NOT(pkt);
   
   int node=hdr->man_not_delegate;
   		
		
   
   int resources[NODENUM];
   int resource_num=srt_.getResourcesOwnedBy(node, resources);
   //I could identically use the entry in the header
   srt_.deleteOwner(node);   
   //DA ottimizzare
   for(int j=0;j<resource_num;j++)
   	{
	    Replica r=srt_.getFromId(resources[j]);
		  int delegate=r.getOwner();
		  if(delegate!=-1)send_replication_request(resources[j], delegate,1);
      #ifdef DEBUG
		      sprintf(out,"%s notified %d %d %d %d",name(),node, delegate, resources[j],
                         srt_.getFromId(resources[j]).getPlacementLength());
		      tcl.eval(out);
		  #endif
	}  
}

/*
 *This method is called when a node receives a request of replication by the manager
 */
 void RedmanAgent::manager_required_replication(Packet* recv_pkt)
 {
  char out[100];
  Tcl& tcl=Tcl::instance();
  hdr_red_req_repl* hdr_req=HDR_RED_REQ_REPL(recv_pkt);
  int resource=hdr_req->req_repl_resource_id;
  int num_replicas=hdr_req->req_repl_copies;
   
  if(my_replica_table_.contains(resource))
  	{
	  #ifdef DEBUG
          sprintf(out,"%s  replicate_on_manager_notify %d %d", name(), resource, num_replicas);
          tcl.eval(out);
	  #endif
         
	  //Store the information needed for the sending of the replication packet
          replication_forwarding_info_=new Replication_Info(nid_,resource,
                                           num_replicas,0,RedmanAgent::replica_hops_);
   
          send_replica_distribution((my_neighbors_table_.get((int)Random::uniform(my_neighbors_table_.length()-1)))->getId(),0);
	}
 
 }
 
 /*
  *The next methods are related to AUM management.
  *AUM send controls the periodic sending of AUM messages from delegates to confirm their presence and the list
  *of resources they own.
  *AUM check is used by the manager to periodically control that the replication degree of resources present in the
  *network is consistent.
  */
  
  void RedmanAgent::aum_send()
  {
   
   Packet* pkt=allocpkt();
   hdr_red_aum* hdr=HDR_RED_AUM(pkt);
   hdr_ip* hdrip=hdr_ip::access(pkt);
   
    
   //Fill the IP header
   hdrip->daddr() = RedmanAgent::manager_id_;
   hdrip->dport()=500;

   //Fill reply fields
   hdr->aum_type=REDMAN_AUM;
   hdr->aum_srcid=nid_;
   hdr->aum_delegate=nid_;
   for(int k=0;k<my_shared_replicas_.length();k++)
   	hdr->aum_resource_id[k]=my_shared_replicas_.get(k).getId();
   hdr->aum_resource_id_num=my_shared_replicas_.length();    
   send(pkt,0);
  
   if(aum_timer_.status()!=TIMER_PENDING) aum_timer_.resched(RedmanAgent::aum_period_+Random::uniform(3));
     
  }
  
  void RedmanAgent::aum_recv(Packet* pkt)
  {
   Tcl tcl=Tcl::instance();
   char out[100];
   
   hdr_red_aum* hdr=HDR_RED_AUM(pkt);
   for(int k=0;k<hdr->aum_resource_id_num;k++)
   	 {
	    Replica* r=new Replica(hdr->aum_resource_id[k], hdr->aum_delegate,
	                 Scheduler::instance().clock()+RedmanAgent::aum_period_*1.2);
	    srt_.update(*r);	
	 	
	 	      #ifdef DEBUG
		      sprintf(out,"%s aum_recv %d %d %f %d",name(), hdr->aum_resource_id[k], hdr->aum_delegate,
	                 Scheduler::instance().clock()+RedmanAgent::aum_period_*1.2,
                   srt_.getFromId(r->getId()).getPlacementLength());
		      tcl.eval(out);
		      #endif
     }   
  }
  
  void RedmanAgent::aum_check()
  {
   Tcl tcl=Tcl::instance();
   char out[100];
   float now=Scheduler::instance().clock();
   Replica r;
   int diff;
   request_new_replicas_queue_= new Message_Queue();
   
               
   srt_.clean(now);
   for(int j=0;j<srt_.length();j++)
   	  {
         r=srt_.get(j);
	       diff=r.getDegree()-r.getPlacementLength();
	       if(diff>0)
	 	       {
		          if(r.getPlacementLength()>0) 
		            request_new_replicas_queue_->insert(r.getId(), r.getPlacement(0),diff);
              #ifdef DEBUG
              	sprintf(out,"%s aum_check %d %d %d %d",name(),r.getId(),r.getPlacement(0),r.getPlacementLength(), diff);
              	tcl.eval(out);
              #endif  
			        for (int s=0;s<r.getPlacementLength();s++)
               {
              	/*#ifdef DEBUG
              	sprintf(out,"%s aum_check %d %d %d",name(),r.getId(),r.getPlacement(s),diff);
              	tcl.eval(out);
              	#endif*/
               }
		       }
	    }
   if(request_new_replicas_queue_->getLength()>0 && aum_extract_timer_.status()!=TIMER_PENDING)
   				aum_extract_timer_.resched(2);
   if(aum_check_timer_.status()!=TIMER_PENDING) aum_check_timer_.resched(RedmanAgent::aum_check_period_);
  }
  
  void RedmanAgent::send_replication_request(int res_id,int delegate, int copies)
  {
	Packet* new_pkt=allocpkt();
	hdr_red_req_repl* hdr_req=HDR_RED_REQ_REPL(new_pkt);
	hdr_ip* hdrip=hdr_ip::access(new_pkt);

	
	hdrip->daddr() = delegate;
	hdrip->dport()=500;

	//Fill reply fields
	hdr_req->req_repl_type=REDMAN_REQUIRE_REPLICATION;
	hdr_req->req_repl_srcid=nid_;
	hdr_req->req_repl_resource_id=res_id;
	hdr_req->req_repl_copies=copies;

	send(new_pkt,0);
}

/**
 *This messages extract and sends one by one the messages present in the Message Queue of the 
 *Manager after an AUM send
 */
void RedmanAgent::extract_from_queue()
{
   Message_Entry* m=request_new_replicas_queue_->drawFirst();
   send_replication_request(m->getId(),m->getDelegate(),m->getCopies());
   if(request_new_replicas_queue_->getLength()>0)
   		aum_extract_timer_.resched(2);
}

/**
 *This messages extract and sends one by one the messages present in the Message Queue of the
 *Manager after an AUM send
 */
void RedmanAgent::extract_from_discharge()
{
   Discharge_Entry* m=discharge_queue_->drawFirst();
   replication_forwarding_info_=m->getReplicationInfo();
   send_replica_distribution(m->getDelegate(),1);
   if(discharge_queue_->getLength()>0)
   		discharge_extract_timer_.resched(0.7);
}


/*==============================NEIGHBORS PROBE PROTOCOL================================================
 =====================================================================================================*/

/*
 *This method is called when a neighbor receives a request to probe how many neighbors match
 *previous candidate replica acceptor neighbors.
 */
void RedmanAgent::recv_probe(Packet* pkt)
{
 int k,j=0;
 float  delay;
 char out[100];
 Tcl& tcl= Tcl::instance();
 hdr_red_probe* hdr=HDR_RED_PROBE(pkt);

 probe_type_=hdr->probe_type;
 
 /*A node can reply only if 
 1)it is a participant
 2)a REDMAN_PROBE packet (i.e., a packet for replica placement)
   for the same pair (resource, delegate) have been already received
 */ 
 if(part_==1 && !(probe_type_==REDMAN_PROBE
             && my_replica_table_.contains(hdr->probe_resource_id,hdr->probe_replica_placement)))
   {
    //Initialize the number of shared neighbors
    shared_neigh_num_=0;
    //Record the current prober
    current_prober_=hdr->probe_srcid;

    //Record the current replica placement depending on the PROBE type
    if(probe_type_==REDMAN_PROBE)  ;
          //replica_placement_=hdr->probe_replica_placement;
    else  current_resource_searched_= hdr->probe_resource_id;
               
          
            #ifdef DEBUG
            sprintf(out, "%s lookup_server",name());
            tcl.eval(out);
            #endif
            
    //Check how many neighbors the previous candidate acceptors shares with the current node
    for(j=0;j<hdr->probe_previous_neigh_num;j++)
         {
          for(k=0;k<my_neighbors_table_.length();k++)
               {
                if(my_neighbors_table_.get(k)->getId()==hdr->probe_previous_neigh[j])
                  {
                   shared_neigh_num_++;
                   break;
                  }
               }
          }

    //Schedule the delay to send the packet
    srand(100);
    delay=rand()/RAND_MAX*RedmanAgent::probe_reply_delay_;
    probe_reply_timer_.resched(Random::uniform(RedmanAgent::probe_reply_delay_));
   }
 
}

/*
 *This method is called when the timeout to send the Probe Reply fires.
 */
void RedmanAgent::send_probe_rep()
{
  //DEBUG
  char out[100];
  Tcl& tcl=Tcl::instance();

  //Allocate the packet
  Packet* pkt=allocpkt();
  //Access the IP header for the new packet
  hdr_ip* hdrip= hdr_ip::access(pkt);
  //Send to the next neighbor
  hdrip->daddr()=current_prober_; 
  hdrip->dport()=500;
  //Access the Replica Distribution header
  hdr_red_probe_rep* hdr=HDR_RED_PROBE_REP(pkt);
  //Set packet probe reply header fields
  hdr->probe_rep_type=REDMAN_PROBE_REP;
  hdr->probe_rep_srcid=nid_;
  hdr->probe_rep_num=shared_neigh_num_;
  hdr->probe_rep_state=probed_state_;
  //Add the found field if the user is searching for a replica placement
  if(probe_type_==REDMAN_SEARCH_PROBE)
        {
          hdr->probe_rep_type=REDMAN_SEARCH_PROBE_REP;
          if(my_replica_table_.contains(current_resource_searched_))
                {
                 hdr->probe_rep_found=1;
                 hdr->probe_rep_replica_placement=reply_placement
                         (my_replica_table_.getFromId(current_resource_searched_));
                 sprintf(out,"%s found", name());
                 tcl.eval(out);                      
                }
          else hdr->probe_rep_found=0;   
        }
  else hdr->probe_rep_type=REDMAN_PROBE_REP;
  send(pkt,0);                                             
}


/*
 *This method handles the Probe Reply packet received from a neighbor
 */
void RedmanAgent::recv_probe_rep(Packet* pkt)
{
  char out[100];
  Tcl& tcl=Tcl::instance();
  //Extract the probe reply header
  hdr_red_probe_rep* hdr=HDR_RED_PROBE_REP(pkt);
  //Record the reply in the tables
  Neighbor* probed_neighbor= new Neighbor(hdr->probe_rep_srcid,-1,hdr->probe_rep_num,0);
  my_probed_neighbors_.insert(*probed_neighbor);
  
  if(hdr->probe_rep_type==REDMAN_SEARCH_PROBE_REP && hdr->probe_rep_found )
          {
           if(!replied_) search_reply(hdr->probe_rep_replica_placement);
           found_=1;
           sprintf(out, "%s found", name());
           tcl.eval(out);
          }
}




 
  /*=============================================================================================*/
  /*===============================================UTILITIES=====================================*/
  /*=============================================================================================*/


  //Functions that prepares a broadcast packet
  Packet* RedmanAgent::BCastPacket()
  {
      // Create a new packet
      Packet* pkt = allocpkt();
      // Access the IP and common headers for the new packet
      hdr_ip* hdrip= hdr_ip::access(pkt);
      hdr_cmn* hdrc= hdr_cmn::access(pkt);
      // Send in Broadcast to all neighbors
      hdrc->next_hop_ = IP_BROADCAST;
      hdrc->addr_type_ = NS_AF_INET;
      hdrip->daddr() = IP_BROADCAST;
      hdrip->dport()=500;
      return (pkt);
  }




  
  
/*=========================================================================================================*/
/*==============                                 REDMAN PARTNER                   =========================*/
/*=========================================================================================================*/


/*
 *Add Redman Partner class to manage broadcast messages: this is fundamental stuff
 */
  RedmanPartner::RedmanPartner() : Connector(), redmanagent_(1),mask_(0xffffffff),
        shift_(8)
    {
        bind("addr_", (int*)&(here_.addr_));
        bind("port_", (int*)&(here_.port_));
        bind("shift_", &shift_);
        bind("mask_", &mask_);
    }

/*
 *The Redman Partner receives packets directly from the Link Layer and forwards them to the Node Entry.
 *If packets are BROADCASTed the Redman Partner changes 255.255.255.255 with the address of the current
 *node. This seems a good way to let nodes receive local broadcast that alternatively are discarded
 *by the routing protocol.
 */
void RedmanPartner::recv(Packet* p, Handler *h)
{
        hdr_ip* hdr = hdr_ip::access(p);
	      hdr_cmn *hdrc = hdr_cmn::access(p);

      	if ( hdrc->ptype() == PT_RED )
                {
                 if (redmanagent_ == 1)
                         {
      	                  if (((u_int32_t)hdr->daddr()) == IP_BROADCAST)
                                 {
      		                        hdr->daddr() = here_.addr_;
      	                         }
      	                 }
                 else {
      	               /* if redmanagent is not installed, drop the packet */
      	               drop (p);
      	               return;
                      }
      	        }
        target_->recv(p,h);
}


int RedmanPartner::command(int argc, const char*const* argv)
{
        if (argc == 3)
           {
      	    if (strcmp (argv[1], "set-redmanagent") == 0)
                {
      	         redmanagent_ = atoi(argv[2]);
      	         return (TCL_OK);
      	        }
           }
       return Connector::command(argc, argv);
}


/*=========================================================================================================
 *                                             TIMERS
 *=========================================================================================================*/

/*=========================================================================================================*/
/*==============                            DENSITY TIMER                   ===============================*/
/*=========================================================================================================*/

void REDDiscoveryTimer::expire(Event *) {
  a_->timeout(RED_DISC);
}

/*=========================================================================================================*/
/*==============                            ADVERTISE TIMER                   =============================*/
/*=========================================================================================================*/

void REDPartAdvTimer::expire(Event *) {
  a_->timeout(RED_ADV);
}


 /*=========================================================================================================*/
 /*==============                      NEXT EXPLORED TIMER                        ==========================*/
 /*=========================================================================================================*/

void NextExploredTimer::expire(Event *) {
  a_->timeout(NEXT_EXPLORED);
}

/*=========================================================================================================*/
/*==============                        DELEGATION          TIMER                 =========================*/
/*=========================================================================================================*/
void DisseminationDelegationTimer::expire(Event*) {
  a_->timeout(DELEGATION);
}

/*=========================================================================================================*/
/*==============                        PROBE WAIT TIMER                 =========================*/
/*=========================================================================================================*/
void ProbeWaitTimer::expire(Event*) {
  a_->timeout(PROBE_WAIT);
}

/*=========================================================================================================*/
/*==============                        PROBE REPLY TIMER                 =========================*/
/*=========================================================================================================*/
void ProbeReplyTimer::expire(Event*) {
  a_->timeout(PROBE_REPLY);
}

/*=========================================================================================================*/
/*==============                        SEARCH PROBE WAIT TIMER                   =========================*/
/*=========================================================================================================*/
void SearchProbeWaitTimer::expire(Event*) {
  a_->timeout(SEARCH_PROBE_WAIT);
}



/*=========================================================================================================*/
/*==============                        SEND_HELLO TIMER                 =========================*/
/*=========================================================================================================*/


void REDSendHelloTimer::expire(Event*) {
   a_->timeout(SND_HELLO);
}

/*=========================================================================================================*/
/*==============                        CHECK_NEIGHBOR TIMER                 =========================*/
/*=========================================================================================================*/
void REDCheckNeighborTimer::expire(Event*) {
  a_->timeout(CHECK_NEIGHBORS);
}

/*=========================================================================================================*/
/*==============                        MANAGER RELATED     TIMER                 =========================*/
/*=========================================================================================================*/
void  REDDelayedProbeTimer::expire(Event*) {
  a_->timeout(PROBE_NEIGHBORS);
}

/*Asynchrnous Update Messages Timer (for delegates)*/
void  REDAUMTimer::expire(Event*) {
  a_->timeout(AUM_SEND);
}

/*AUM Check Timer (for manager's check)*/
void  REDAUMCheckTimer::expire(Event*) {
  a_->timeout(AUM_CHECK);
}


/*AUM Check Timer (for manager's check)*/
void  REDAUMExtractTimer::expire(Event*) {
  a_->timeout(AUM_EXTRACT);
}

/*AUM Check Timer (for manager's check)*/
void  REDDischargeExtractTimer::expire(Event*) {
  a_->timeout(DISCHARGE_EXTRACT);
}

