
#ifndef __node_num__
#define __node_num__
const int NODENUM=60;
#endif


#include <random.h>

#ifndef __replication_info_h__
#define __replication_info_h__

class Replication_Info{

      private:
           int resource_delegate;
           int resource_id;
           int resource_num_replicas_required;
           int resource_acceptors_num;
           int resource_acceptors[NODENUM];
           int resource_hops_to_next;
           int resource_is_delegate_exiting;
           int resource_exiting_delegate;

      public:
           Replication_Info(int rd, int rid, int rhtn)
                    {
                     resource_delegate=rd;
                     resource_id=rid;
                     resource_hops_to_next=rhtn;
                     resource_is_delegate_exiting=0;
                    }
                    
           Replication_Info(int rd, int rid, int rnrr, int ran, int rhtn)
                    {
                     resource_delegate=rd;
                     resource_id=rid;
                     resource_num_replicas_required=rnrr;
                     resource_acceptors_num=ran;
                     resource_hops_to_next=rhtn;
                     resource_is_delegate_exiting=0;
                    }
                    
           Replication_Info(int rd, int rid, int rnrr, int ran, int rhtn, int isdelexit, int exitdel)
                    {
                     resource_delegate=rd;
                     resource_id=rid;
                     resource_num_replicas_required=rnrr;
                     resource_acceptors_num=ran;
                     resource_hops_to_next=rhtn;
                     resource_is_delegate_exiting=isdelexit;
                     resource_exiting_delegate=exitdel;
                    }
         

           Replication_Info(int rd, int rid, int rnrr, int ran, int* ra, int rhtn, int isdelexit, int exitdel)
                    {
                     resource_delegate=rd;
                     resource_id=rid;
                     resource_num_replicas_required=rnrr;
                     resource_acceptors_num=ran;
                     resource_hops_to_next=rhtn;
                     for(int j=0;j<ran;j++)
                          resource_acceptors[j]=ra[j];
                     resource_is_delegate_exiting=0;
                     resource_is_delegate_exiting=isdelexit;
                     resource_exiting_delegate=exitdel;       
                    }
           Replication_Info(Replication_Info* rep)
                    {
                     resource_delegate=rep->getDelegate();
                     resource_id=rep->getResourceId();
                     resource_num_replicas_required=rep->getNumReplicasRequired();
                     resource_acceptors_num=rep->getAcceptorsNum();
                     resource_hops_to_next=rep->getHopsToNext();
                     rep->getAcceptors(resource_acceptors);
                     resource_is_delegate_exiting=rep->isDelegateExiting();
                     resource_exiting_delegate=rep->getExitingDelegate();
                    }
                    
           int getDelegate() {return resource_delegate;}
           int getResourceId() {return resource_id;}
           int getNumReplicasRequired () {return resource_num_replicas_required;}
           int getAcceptorsNum () {return resource_acceptors_num;}
           void getAcceptors (int *ret) {
                               for(int j=0;j<resource_acceptors_num;j++)
                                      ret[j]=resource_acceptors[j];                               
                               }
           int getHopsToNext () {return resource_hops_to_next;}
           int isDelegateExiting() {return resource_is_delegate_exiting;}
           int getExitingDelegate(){return resource_exiting_delegate;}
           
           void setDelegate(int del) {resource_delegate=del;}
           void setResourceId(int id) {resource_id=id;}
           void setNumReplicasRequired (int nrr) {resource_num_replicas_required=nrr;}
           void setAcceptorsNum (int an) {resource_acceptors_num=an;}
           void setAcceptors (int *ret, int an) {
                               for(int j=0;j<an;j++)
                                      resource_acceptors[j]=ret[j];
                               resource_acceptors_num=an;
                               }
           void setHopsToNext (int hops) {resource_hops_to_next=hops;}
           void decNumReplicasRequired () {resource_num_replicas_required--;}
           void addAcceptor (int id) {
                               resource_acceptors[resource_acceptors_num++]=id;
                               }
           
};

#endif

